//+------------------------------------------------------------------+
//|                                        Trailing Stop Manager.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Complete Currency Trader Ltd"
#property link      "http://completecurrencytrader.com/"
#property version   "1.00"
#property strict

extern int TrailDistance = 200;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{   
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   for(int i = OrdersTotal()-1; i >= 0; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS))
      {
         // only handle trades on the current symbol
         if(OrderSymbol() == Symbol())
         {
            if(OrderType() == OP_BUY)
            {
               // move stop upward if price moves up
               if(NormalizeDouble(Bid - TrailDistance*Point, Digits) > NormalizeDouble(OrderStopLoss(), Digits))
               {
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-TrailDistance*Point, Digits),OrderTakeProfit(),0))
                     Print("Modified stop for order ", OrderTicket(), " on ", OrderSymbol());
                  else
                     Print("Error modifying stop for order ", OrderTicket(), " on ", OrderSymbol());
               }
            }   
            if(OrderType() == OP_SELL)
            {
               // move stop downward if price moves down
               if(NormalizeDouble(Ask + TrailDistance*Point, Digits) < NormalizeDouble(OrderStopLoss(), Digits))
               {
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+TrailDistance*Point, Digits),OrderTakeProfit(),0))
                     Print("Modified stop for order ", OrderTicket(), " on ", OrderSymbol());
                  else
                     Print("Error modifying stop for order ", OrderTicket(), " on ", OrderSymbol());
               }
            }            
         }
      }
   }
}